/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;

/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the AuthenticationConfiguration
 *  Element in the SSH API configuration file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshAPIConfiguration.dtd &
 *  SshAPIConfiguration.xjs; the only amendment to the source code is to insert
 *  the package at the beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */

public class AuthenticationConfiguration
         extends MarshallableObject
         implements Element {

    private List _AuthenticationMethod = PredicatedLists.createInvalidating(this, new AuthenticationMethodPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_AuthenticationMethod = new AuthenticationMethodPredicate();


    /**
     *  Gets the authenticationMethod attribute of the
     *  AuthenticationConfiguration object
     *
     *@return    The authenticationMethod value
     */
    public List getAuthenticationMethod() {
        return _AuthenticationMethod;
    }


    /**
     *  Description of the Method
     */
    public void deleteAuthenticationMethod() {
        _AuthenticationMethod = null;
        invalidate();
    }


    /**
     *  Description of the Method
     */
    public void emptyAuthenticationMethod() {
        _AuthenticationMethod = PredicatedLists.createInvalidating(this, pred_AuthenticationMethod, new ArrayList());
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException { }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException {
        for (Iterator i = _AuthenticationMethod.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("AuthenticationConfiguration");
        if (_AuthenticationMethod.size() > 0) {
            for (Iterator i = _AuthenticationMethod.iterator(); i.hasNext(); ) {
                m.marshal(((MarshallableObject) i.next()));
            }
        }
        w.end("AuthenticationConfiguration");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("AuthenticationConfiguration");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
         {
            List l = PredicatedLists.create(this, pred_AuthenticationMethod, new ArrayList());
            while (xs.atStart("AuthenticationMethod")) {
                l.add(((AuthenticationMethod) u.unmarshal()));
            }
            _AuthenticationMethod = PredicatedLists.createInvalidating(this, pred_AuthenticationMethod, l);
        }
        xs.takeEnd("AuthenticationConfiguration");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static AuthenticationConfiguration unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static AuthenticationConfiguration unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static AuthenticationConfiguration unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((AuthenticationConfiguration) d.unmarshal(xs, (AuthenticationConfiguration.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof AuthenticationConfiguration)) {
            return false;
        }
        AuthenticationConfiguration tob = ((AuthenticationConfiguration) ob);
        if (_AuthenticationMethod != null) {
            if (tob._AuthenticationMethod == null) {
                return false;
            }
            if (!_AuthenticationMethod.equals(tob._AuthenticationMethod)) {
                return false;
            }
        } else {
            if (tob._AuthenticationMethod != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_AuthenticationMethod != null) ? _AuthenticationMethod.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<AuthenticationConfiguration");
        if (_AuthenticationMethod != null) {
            sb.append(" AuthenticationMethod=");
            sb.append(_AuthenticationMethod.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        Dispatcher d = new Dispatcher();
        d.register("AuthenticationConfiguration", (AuthenticationConfiguration.class));
        d.register("AuthenticationMethod", (AuthenticationMethod.class));
        d.register("CipherAlgorithm", (CipherAlgorithm.class));
        d.register("CipherConfiguration", (CipherConfiguration.class));
        d.register("CompressionAlgorithm", (CompressionAlgorithm.class));
        d.register("CompressionConfiguration", (CompressionConfiguration.class));
        d.register("KeyExchangeAlgorithm", (KeyExchangeAlgorithm.class));
        d.register("KeyExchangeConfiguration", (KeyExchangeConfiguration.class));
        d.register("MacAlgorithm", (MacAlgorithm.class));
        d.register("MacConfiguration", (MacConfiguration.class));
        d.register("PublicKeyAlgorithm", (PublicKeyAlgorithm.class));
        d.register("PublicKeyConfiguration", (PublicKeyConfiguration.class));
        d.register("SshAPIConfiguration", (SshAPIConfiguration.class));
        d.freezeElementNameMap();
        return d;
    }


    /**
     *  Description of the Class
     *
     *@author     lee
     */
    private static class AuthenticationMethodPredicate
             implements PredicatedLists.Predicate {

        /**
         *  Description of the Method
         *
         *@param  ob  Description of the Parameter
         */
        public void check(Object ob) {
            if (!(ob instanceof AuthenticationMethod)) {
                throw new InvalidContentObjectException(ob, (AuthenticationMethod.class));
            }
        }

    }

}
