/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;

/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the AuthenticationMethod Element
 *  in the SSH API configuration file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshAPIConfiguration.dtd &
 *  SshAPIConfiguration.xjs; the only amendment to the source code is to insert
 *  the package at the beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */
public class AuthenticationMethod
         extends MarshallableObject
         implements Element {

    private String _DisplayName;
    private String _MethodName;
    private String _ImplementationClass;


    /**
     *  Gets the displayName attribute of the AuthenticationMethod object
     *
     *@return    The displayName value
     */
    public String getDisplayName() {
        return _DisplayName;
    }


    /**
     *  Sets the displayName attribute of the AuthenticationMethod object
     *
     *@param  _DisplayName  The new displayName value
     */
    public void setDisplayName(String _DisplayName) {
        this._DisplayName = _DisplayName;
        if (_DisplayName == null) {
            invalidate();
        }
    }


    /**
     *  Gets the methodName attribute of the AuthenticationMethod object
     *
     *@return    The methodName value
     */
    public String getMethodName() {
        return _MethodName;
    }


    /**
     *  Sets the methodName attribute of the AuthenticationMethod object
     *
     *@param  _MethodName  The new methodName value
     */
    public void setMethodName(String _MethodName) {
        this._MethodName = _MethodName;
        if (_MethodName == null) {
            invalidate();
        }
    }


    /**
     *  Gets the implementationClass attribute of the AuthenticationMethod
     *  object
     *
     *@return    The implementationClass value
     */
    public String getImplementationClass() {
        return _ImplementationClass;
    }


    /**
     *  Sets the implementationClass attribute of the AuthenticationMethod
     *  object
     *
     *@param  _ImplementationClass  The new implementationClass value
     */
    public void setImplementationClass(String _ImplementationClass) {
        this._ImplementationClass = _ImplementationClass;
        if (_ImplementationClass == null) {
            invalidate();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException {
        if (_DisplayName == null) {
            throw new MissingContentException("displayName");
        }
        if (_MethodName == null) {
            throw new MissingContentException("methodName");
        }
        if (_ImplementationClass == null) {
            throw new MissingContentException("implementationClass");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException { }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("AuthenticationMethod");
        w.leaf("displayName", _DisplayName.toString());
        w.leaf("methodName", _MethodName.toString());
        w.leaf("implementationClass", _ImplementationClass.toString());
        w.end("AuthenticationMethod");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("AuthenticationMethod");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("displayName")) {
            xs.takeStart("displayName");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _DisplayName = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("displayName", x);
            }
            xs.takeEnd("displayName");
        }
        if (xs.atStart("methodName")) {
            xs.takeStart("methodName");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _MethodName = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("methodName", x);
            }
            xs.takeEnd("methodName");
        }
        if (xs.atStart("implementationClass")) {
            xs.takeStart("implementationClass");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _ImplementationClass = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("implementationClass", x);
            }
            xs.takeEnd("implementationClass");
        }
        xs.takeEnd("AuthenticationMethod");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static AuthenticationMethod unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static AuthenticationMethod unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static AuthenticationMethod unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((AuthenticationMethod) d.unmarshal(xs, (AuthenticationMethod.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof AuthenticationMethod)) {
            return false;
        }
        AuthenticationMethod tob = ((AuthenticationMethod) ob);
        if (_DisplayName != null) {
            if (tob._DisplayName == null) {
                return false;
            }
            if (!_DisplayName.equals(tob._DisplayName)) {
                return false;
            }
        } else {
            if (tob._DisplayName != null) {
                return false;
            }
        }
        if (_MethodName != null) {
            if (tob._MethodName == null) {
                return false;
            }
            if (!_MethodName.equals(tob._MethodName)) {
                return false;
            }
        } else {
            if (tob._MethodName != null) {
                return false;
            }
        }
        if (_ImplementationClass != null) {
            if (tob._ImplementationClass == null) {
                return false;
            }
            if (!_ImplementationClass.equals(tob._ImplementationClass)) {
                return false;
            }
        } else {
            if (tob._ImplementationClass != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_DisplayName != null) ? _DisplayName.hashCode() : 0));
        h = ((127 * h) + ((_MethodName != null) ? _MethodName.hashCode() : 0));
        h = ((127 * h) + ((_ImplementationClass != null) ? _ImplementationClass.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<AuthenticationMethod");
        if (_DisplayName != null) {
            sb.append(" displayName=");
            sb.append(_DisplayName.toString());
        }
        if (_MethodName != null) {
            sb.append(" methodName=");
            sb.append(_MethodName.toString());
        }
        if (_ImplementationClass != null) {
            sb.append(" implementationClass=");
            sb.append(_ImplementationClass.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return AuthenticationConfiguration.newDispatcher();
    }

}
