/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the CompressionAlgorithm Element
 *  in the SSH API configuration file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshAPIConfiguration.dtd &
 *  SshAPIConfiguration.xjs; the only amendment to the source code is to insert
 *  the package at the beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */

public class CompressionAlgorithm
         extends MarshallableObject
         implements Element {

    private String _AlgorithmName;
    private String _ImplementationClass;


    /**
     *  Gets the algorithmName attribute of the CompressionAlgorithm object
     *
     *@return    The algorithmName value
     */
    public String getAlgorithmName() {
        return _AlgorithmName;
    }


    /**
     *  Sets the algorithmName attribute of the CompressionAlgorithm object
     *
     *@param  _AlgorithmName  The new algorithmName value
     */
    public void setAlgorithmName(String _AlgorithmName) {
        this._AlgorithmName = _AlgorithmName;
        if (_AlgorithmName == null) {
            invalidate();
        }
    }


    /**
     *  Gets the implementationClass attribute of the CompressionAlgorithm
     *  object
     *
     *@return    The implementationClass value
     */
    public String getImplementationClass() {
        return _ImplementationClass;
    }


    /**
     *  Sets the implementationClass attribute of the CompressionAlgorithm
     *  object
     *
     *@param  _ImplementationClass  The new implementationClass value
     */
    public void setImplementationClass(String _ImplementationClass) {
        this._ImplementationClass = _ImplementationClass;
        if (_ImplementationClass == null) {
            invalidate();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException {
        if (_AlgorithmName == null) {
            throw new MissingContentException("algorithmName");
        }
        if (_ImplementationClass == null) {
            throw new MissingContentException("implementationClass");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException { }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("CompressionAlgorithm");
        w.leaf("algorithmName", _AlgorithmName.toString());
        w.leaf("implementationClass", _ImplementationClass.toString());
        w.end("CompressionAlgorithm");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("CompressionAlgorithm");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("algorithmName")) {
            xs.takeStart("algorithmName");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _AlgorithmName = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("algorithmName", x);
            }
            xs.takeEnd("algorithmName");
        }
        if (xs.atStart("implementationClass")) {
            xs.takeStart("implementationClass");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _ImplementationClass = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("implementationClass", x);
            }
            xs.takeEnd("implementationClass");
        }
        xs.takeEnd("CompressionAlgorithm");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static CompressionAlgorithm unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static CompressionAlgorithm unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static CompressionAlgorithm unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((CompressionAlgorithm) d.unmarshal(xs, (CompressionAlgorithm.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof CompressionAlgorithm)) {
            return false;
        }
        CompressionAlgorithm tob = ((CompressionAlgorithm) ob);
        if (_AlgorithmName != null) {
            if (tob._AlgorithmName == null) {
                return false;
            }
            if (!_AlgorithmName.equals(tob._AlgorithmName)) {
                return false;
            }
        } else {
            if (tob._AlgorithmName != null) {
                return false;
            }
        }
        if (_ImplementationClass != null) {
            if (tob._ImplementationClass == null) {
                return false;
            }
            if (!_ImplementationClass.equals(tob._ImplementationClass)) {
                return false;
            }
        } else {
            if (tob._ImplementationClass != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_AlgorithmName != null) ? _AlgorithmName.hashCode() : 0));
        h = ((127 * h) + ((_ImplementationClass != null) ? _ImplementationClass.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<CompressionAlgorithm");
        if (_AlgorithmName != null) {
            sb.append(" algorithmName=");
            sb.append(_AlgorithmName.toString());
        }
        if (_ImplementationClass != null) {
            sb.append(" implementationClass=");
            sb.append(_ImplementationClass.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return AuthenticationConfiguration.newDispatcher();
    }

}
