/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the MacConfiguration Element in
 *  the SSH API configuration file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshAPIConfiguration.dtd &
 *  SshAPIConfiguration.xjs; the only amendment to the source code is to insert
 *  this message before the class declaration and the package name at the
 *  beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */

public class MacConfiguration
         extends MarshallableObject
         implements Element {

    private List _MacAlgorithm = PredicatedLists.createInvalidating(this, new MacAlgorithmPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_MacAlgorithm = new MacAlgorithmPredicate();
    private String _DefaultAlgorithm;


    /**
     *  Gets the macAlgorithm attribute of the MacConfiguration object
     *
     *@return    The macAlgorithm value
     */
    public List getMacAlgorithm() {
        return _MacAlgorithm;
    }


    /**
     *  Description of the Method
     */
    public void deleteMacAlgorithm() {
        _MacAlgorithm = null;
        invalidate();
    }


    /**
     *  Description of the Method
     */
    public void emptyMacAlgorithm() {
        _MacAlgorithm = PredicatedLists.createInvalidating(this, pred_MacAlgorithm, new ArrayList());
    }


    /**
     *  Gets the defaultAlgorithm attribute of the MacConfiguration object
     *
     *@return    The defaultAlgorithm value
     */
    public String getDefaultAlgorithm() {
        return _DefaultAlgorithm;
    }


    /**
     *  Sets the defaultAlgorithm attribute of the MacConfiguration object
     *
     *@param  _DefaultAlgorithm  The new defaultAlgorithm value
     */
    public void setDefaultAlgorithm(String _DefaultAlgorithm) {
        this._DefaultAlgorithm = _DefaultAlgorithm;
        if (_DefaultAlgorithm == null) {
            invalidate();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException {
        if (_DefaultAlgorithm == null) {
            throw new MissingContentException("defaultAlgorithm");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException {
        for (Iterator i = _MacAlgorithm.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("MacConfiguration");
        if (_MacAlgorithm.size() > 0) {
            for (Iterator i = _MacAlgorithm.iterator(); i.hasNext(); ) {
                m.marshal(((MarshallableObject) i.next()));
            }
        }
        w.leaf("defaultAlgorithm", _DefaultAlgorithm.toString());
        w.end("MacConfiguration");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("MacConfiguration");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
         {
            List l = PredicatedLists.create(this, pred_MacAlgorithm, new ArrayList());
            while (xs.atStart("MacAlgorithm")) {
                l.add(((MacAlgorithm) u.unmarshal()));
            }
            _MacAlgorithm = PredicatedLists.createInvalidating(this, pred_MacAlgorithm, l);
        }
        if (xs.atStart("defaultAlgorithm")) {
            xs.takeStart("defaultAlgorithm");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _DefaultAlgorithm = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("defaultAlgorithm", x);
            }
            xs.takeEnd("defaultAlgorithm");
        }
        xs.takeEnd("MacConfiguration");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static MacConfiguration unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static MacConfiguration unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static MacConfiguration unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((MacConfiguration) d.unmarshal(xs, (MacConfiguration.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof MacConfiguration)) {
            return false;
        }
        MacConfiguration tob = ((MacConfiguration) ob);
        if (_MacAlgorithm != null) {
            if (tob._MacAlgorithm == null) {
                return false;
            }
            if (!_MacAlgorithm.equals(tob._MacAlgorithm)) {
                return false;
            }
        } else {
            if (tob._MacAlgorithm != null) {
                return false;
            }
        }
        if (_DefaultAlgorithm != null) {
            if (tob._DefaultAlgorithm == null) {
                return false;
            }
            if (!_DefaultAlgorithm.equals(tob._DefaultAlgorithm)) {
                return false;
            }
        } else {
            if (tob._DefaultAlgorithm != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_MacAlgorithm != null) ? _MacAlgorithm.hashCode() : 0));
        h = ((127 * h) + ((_DefaultAlgorithm != null) ? _DefaultAlgorithm.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<MacConfiguration");
        if (_MacAlgorithm != null) {
            sb.append(" MacAlgorithm=");
            sb.append(_MacAlgorithm.toString());
        }
        if (_DefaultAlgorithm != null) {
            sb.append(" defaultAlgorithm=");
            sb.append(_DefaultAlgorithm.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return AuthenticationConfiguration.newDispatcher();
    }


    /**
     *  Description of the Class
     *
     *@author     lee
     */
    private static class MacAlgorithmPredicate
             implements PredicatedLists.Predicate {

        /**
         *  Description of the Method
         *
         *@param  ob  Description of the Parameter
         */
        public void check(Object ob) {
            if (!(ob instanceof MacAlgorithm)) {
                throw new InvalidContentObjectException(ob, (MacAlgorithm.class));
            }
        }

    }

}
