/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;

/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the PreferredEncryption Element
 *  in the SshConnection xml file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshConnection.dtd &
 *  SshConnection.xjs; the only amendment to the source code is to insert the
 *  package at the beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */

public class PreferredEncryption
         extends MarshallableObject
         implements Element {

    private String _ClientToServer;
    private String _ServerToClient;


    /**
     *  Gets the clientToServer attribute of the PreferredEncryption object
     *
     *@return    The clientToServer value
     */
    public String getClientToServer() {
        return _ClientToServer;
    }


    /**
     *  Sets the clientToServer attribute of the PreferredEncryption object
     *
     *@param  _ClientToServer  The new clientToServer value
     */
    public void setClientToServer(String _ClientToServer) {
        this._ClientToServer = _ClientToServer;
        if (_ClientToServer == null) {
            invalidate();
        }
    }


    /**
     *  Gets the serverToClient attribute of the PreferredEncryption object
     *
     *@return    The serverToClient value
     */
    public String getServerToClient() {
        return _ServerToClient;
    }


    /**
     *  Sets the serverToClient attribute of the PreferredEncryption object
     *
     *@param  _ServerToClient  The new serverToClient value
     */
    public void setServerToClient(String _ServerToClient) {
        this._ServerToClient = _ServerToClient;
        if (_ServerToClient == null) {
            invalidate();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException {
        if (_ClientToServer == null) {
            throw new MissingContentException("ClientToServer");
        }
        if (_ServerToClient == null) {
            throw new MissingContentException("ServerToClient");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException { }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("PreferredEncryption");
        w.leaf("ClientToServer", _ClientToServer.toString());
        w.leaf("ServerToClient", _ServerToClient.toString());
        w.end("PreferredEncryption");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("PreferredEncryption");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("ClientToServer")) {
            xs.takeStart("ClientToServer");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _ClientToServer = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("ClientToServer", x);
            }
            xs.takeEnd("ClientToServer");
        }
        if (xs.atStart("ServerToClient")) {
            xs.takeStart("ServerToClient");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _ServerToClient = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("ServerToClient", x);
            }
            xs.takeEnd("ServerToClient");
        }
        xs.takeEnd("PreferredEncryption");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static PreferredEncryption unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static PreferredEncryption unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static PreferredEncryption unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((PreferredEncryption) d.unmarshal(xs, (PreferredEncryption.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof PreferredEncryption)) {
            return false;
        }
        PreferredEncryption tob = ((PreferredEncryption) ob);
        if (_ClientToServer != null) {
            if (tob._ClientToServer == null) {
                return false;
            }
            if (!_ClientToServer.equals(tob._ClientToServer)) {
                return false;
            }
        } else {
            if (tob._ClientToServer != null) {
                return false;
            }
        }
        if (_ServerToClient != null) {
            if (tob._ServerToClient == null) {
                return false;
            }
            if (!_ServerToClient.equals(tob._ServerToClient)) {
                return false;
            }
        } else {
            if (tob._ServerToClient != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_ClientToServer != null) ? _ClientToServer.hashCode() : 0));
        h = ((127 * h) + ((_ServerToClient != null) ? _ServerToClient.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<PreferredEncryption");
        if (_ClientToServer != null) {
            sb.append(" ClientToServer=");
            sb.append(_ClientToServer.toString());
        }
        if (_ServerToClient != null) {
            sb.append(" ServerToClient=");
            sb.append(_ServerToClient.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return PreferredCompression.newDispatcher();
    }

}
