/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the SshAPIConfiguration Element
 *  in the SSH API configuration file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshAPIConfiguration.dtd &
 *  SshAPIConfiguration.xjs; the only amendment to the source code is to insert
 *  this message before the class declaration and the package name at the
 *  beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */
public class SshAPIConfiguration
         extends MarshallableRootElement
         implements RootElement {

    private CipherConfiguration _CipherConfiguration;
    private MacConfiguration _MacConfiguration;
    private CompressionConfiguration _CompressionConfiguration;
    private PublicKeyConfiguration _PublicKeyConfiguration;
    private AuthenticationConfiguration _AuthenticationConfiguration;
    private KeyExchangeConfiguration _KeyExchangeConfiguration;


    /**
     *  Gets the cipherConfiguration attribute of the SshAPIConfiguration object
     *
     *@return    The cipherConfiguration value
     */
    public CipherConfiguration getCipherConfiguration() {
        return _CipherConfiguration;
    }


    /**
     *  Sets the cipherConfiguration attribute of the SshAPIConfiguration object
     *
     *@param  _CipherConfiguration  The new cipherConfiguration value
     */
    public void setCipherConfiguration(CipherConfiguration _CipherConfiguration) {
        this._CipherConfiguration = _CipherConfiguration;
        if (_CipherConfiguration == null) {
            invalidate();
        }
    }


    /**
     *  Gets the macConfiguration attribute of the SshAPIConfiguration object
     *
     *@return    The macConfiguration value
     */
    public MacConfiguration getMacConfiguration() {
        return _MacConfiguration;
    }


    /**
     *  Sets the macConfiguration attribute of the SshAPIConfiguration object
     *
     *@param  _MacConfiguration  The new macConfiguration value
     */
    public void setMacConfiguration(MacConfiguration _MacConfiguration) {
        this._MacConfiguration = _MacConfiguration;
        if (_MacConfiguration == null) {
            invalidate();
        }
    }


    /**
     *  Gets the compressionConfiguration attribute of the SshAPIConfiguration
     *  object
     *
     *@return    The compressionConfiguration value
     */
    public CompressionConfiguration getCompressionConfiguration() {
        return _CompressionConfiguration;
    }


    /**
     *  Sets the compressionConfiguration attribute of the SshAPIConfiguration
     *  object
     *
     *@param  _CompressionConfiguration  The new compressionConfiguration value
     */
    public void setCompressionConfiguration(CompressionConfiguration _CompressionConfiguration) {
        this._CompressionConfiguration = _CompressionConfiguration;
        if (_CompressionConfiguration == null) {
            invalidate();
        }
    }


    /**
     *  Gets the publicKeyConfiguration attribute of the SshAPIConfiguration
     *  object
     *
     *@return    The publicKeyConfiguration value
     */
    public PublicKeyConfiguration getPublicKeyConfiguration() {
        return _PublicKeyConfiguration;
    }


    /**
     *  Sets the publicKeyConfiguration attribute of the SshAPIConfiguration
     *  object
     *
     *@param  _PublicKeyConfiguration  The new publicKeyConfiguration value
     */
    public void setPublicKeyConfiguration(PublicKeyConfiguration _PublicKeyConfiguration) {
        this._PublicKeyConfiguration = _PublicKeyConfiguration;
        if (_PublicKeyConfiguration == null) {
            invalidate();
        }
    }


    /**
     *  Gets the authenticationConfiguration attribute of the
     *  SshAPIConfiguration object
     *
     *@return    The authenticationConfiguration value
     */
    public AuthenticationConfiguration getAuthenticationConfiguration() {
        return _AuthenticationConfiguration;
    }


    /**
     *  Sets the authenticationConfiguration attribute of the
     *  SshAPIConfiguration object
     *
     *@param  _AuthenticationConfiguration  The new authenticationConfiguration
     *      value
     */
    public void setAuthenticationConfiguration(AuthenticationConfiguration _AuthenticationConfiguration) {
        this._AuthenticationConfiguration = _AuthenticationConfiguration;
        if (_AuthenticationConfiguration == null) {
            invalidate();
        }
    }


    /**
     *  Gets the keyExchangeConfiguration attribute of the SshAPIConfiguration
     *  object
     *
     *@return    The keyExchangeConfiguration value
     */
    public KeyExchangeConfiguration getKeyExchangeConfiguration() {
        return _KeyExchangeConfiguration;
    }


    /**
     *  Sets the keyExchangeConfiguration attribute of the SshAPIConfiguration
     *  object
     *
     *@param  _KeyExchangeConfiguration  The new keyExchangeConfiguration value
     */
    public void setKeyExchangeConfiguration(KeyExchangeConfiguration _KeyExchangeConfiguration) {
        this._KeyExchangeConfiguration = _KeyExchangeConfiguration;
        if (_KeyExchangeConfiguration == null) {
            invalidate();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException {
        if (_CipherConfiguration == null) {
            throw new MissingContentException("CipherConfiguration");
        }
        if (_MacConfiguration == null) {
            throw new MissingContentException("MacConfiguration");
        }
        if (_CompressionConfiguration == null) {
            throw new MissingContentException("CompressionConfiguration");
        }
        if (_PublicKeyConfiguration == null) {
            throw new MissingContentException("PublicKeyConfiguration");
        }
        if (_AuthenticationConfiguration == null) {
            throw new MissingContentException("AuthenticationConfiguration");
        }
        if (_KeyExchangeConfiguration == null) {
            throw new MissingContentException("KeyExchangeConfiguration");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException {
        v.validate(_CipherConfiguration);
        v.validate(_MacConfiguration);
        v.validate(_CompressionConfiguration);
        v.validate(_PublicKeyConfiguration);
        v.validate(_AuthenticationConfiguration);
        v.validate(_KeyExchangeConfiguration);
    }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("SshAPIConfiguration");
        m.marshal(_CipherConfiguration);
        m.marshal(_MacConfiguration);
        m.marshal(_CompressionConfiguration);
        m.marshal(_PublicKeyConfiguration);
        m.marshal(_AuthenticationConfiguration);
        m.marshal(_KeyExchangeConfiguration);
        w.end("SshAPIConfiguration");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("SshAPIConfiguration");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        _CipherConfiguration = ((CipherConfiguration) u.unmarshal());
        _MacConfiguration = ((MacConfiguration) u.unmarshal());
        _CompressionConfiguration = ((CompressionConfiguration) u.unmarshal());
        _PublicKeyConfiguration = ((PublicKeyConfiguration) u.unmarshal());
        _AuthenticationConfiguration = ((AuthenticationConfiguration) u.unmarshal());
        _KeyExchangeConfiguration = ((KeyExchangeConfiguration) u.unmarshal());
        xs.takeEnd("SshAPIConfiguration");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static SshAPIConfiguration unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static SshAPIConfiguration unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static SshAPIConfiguration unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((SshAPIConfiguration) d.unmarshal(xs, (SshAPIConfiguration.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof SshAPIConfiguration)) {
            return false;
        }
        SshAPIConfiguration tob = ((SshAPIConfiguration) ob);
        if (_CipherConfiguration != null) {
            if (tob._CipherConfiguration == null) {
                return false;
            }
            if (!_CipherConfiguration.equals(tob._CipherConfiguration)) {
                return false;
            }
        } else {
            if (tob._CipherConfiguration != null) {
                return false;
            }
        }
        if (_MacConfiguration != null) {
            if (tob._MacConfiguration == null) {
                return false;
            }
            if (!_MacConfiguration.equals(tob._MacConfiguration)) {
                return false;
            }
        } else {
            if (tob._MacConfiguration != null) {
                return false;
            }
        }
        if (_CompressionConfiguration != null) {
            if (tob._CompressionConfiguration == null) {
                return false;
            }
            if (!_CompressionConfiguration.equals(tob._CompressionConfiguration)) {
                return false;
            }
        } else {
            if (tob._CompressionConfiguration != null) {
                return false;
            }
        }
        if (_PublicKeyConfiguration != null) {
            if (tob._PublicKeyConfiguration == null) {
                return false;
            }
            if (!_PublicKeyConfiguration.equals(tob._PublicKeyConfiguration)) {
                return false;
            }
        } else {
            if (tob._PublicKeyConfiguration != null) {
                return false;
            }
        }
        if (_AuthenticationConfiguration != null) {
            if (tob._AuthenticationConfiguration == null) {
                return false;
            }
            if (!_AuthenticationConfiguration.equals(tob._AuthenticationConfiguration)) {
                return false;
            }
        } else {
            if (tob._AuthenticationConfiguration != null) {
                return false;
            }
        }
        if (_KeyExchangeConfiguration != null) {
            if (tob._KeyExchangeConfiguration == null) {
                return false;
            }
            if (!_KeyExchangeConfiguration.equals(tob._KeyExchangeConfiguration)) {
                return false;
            }
        } else {
            if (tob._KeyExchangeConfiguration != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_CipherConfiguration != null) ? _CipherConfiguration.hashCode() : 0));
        h = ((127 * h) + ((_MacConfiguration != null) ? _MacConfiguration.hashCode() : 0));
        h = ((127 * h) + ((_CompressionConfiguration != null) ? _CompressionConfiguration.hashCode() : 0));
        h = ((127 * h) + ((_PublicKeyConfiguration != null) ? _PublicKeyConfiguration.hashCode() : 0));
        h = ((127 * h) + ((_AuthenticationConfiguration != null) ? _AuthenticationConfiguration.hashCode() : 0));
        h = ((127 * h) + ((_KeyExchangeConfiguration != null) ? _KeyExchangeConfiguration.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<SshAPIConfiguration");
        if (_CipherConfiguration != null) {
            sb.append(" CipherConfiguration=");
            sb.append(_CipherConfiguration.toString());
        }
        if (_MacConfiguration != null) {
            sb.append(" MacConfiguration=");
            sb.append(_MacConfiguration.toString());
        }
        if (_CompressionConfiguration != null) {
            sb.append(" CompressionConfiguration=");
            sb.append(_CompressionConfiguration.toString());
        }
        if (_PublicKeyConfiguration != null) {
            sb.append(" PublicKeyConfiguration=");
            sb.append(_PublicKeyConfiguration.toString());
        }
        if (_AuthenticationConfiguration != null) {
            sb.append(" AuthenticationConfiguration=");
            sb.append(_AuthenticationConfiguration.toString());
        }
        if (_KeyExchangeConfiguration != null) {
            sb.append(" KeyExchangeConfiguration=");
            sb.append(_KeyExchangeConfiguration.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return AuthenticationConfiguration.newDispatcher();
    }

}
