/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.configuration;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.DuplicateAttributeException;
import javax.xml.bind.IdentifiableElement;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingAttributeException;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;

/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the SshConnection Element in the
 *  SshConnection xml file.</p> <p>
 *
 *  NOTE: This file should always be generated from SshConnection.dtd &
 *  SshConnection.xjs; the only amendment to the source code is to insert the
 *  package at the beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@version    1.0
 */
public class SshConnection
         extends MarshallableRootElement
         implements RootElement, IdentifiableElement {

    private String _Hostname;
    private String _Port;
    private String _Username;
    private String _TerminalType;
    private PreferredEncryption _PreferredEncryption;
    private PreferredMac _PreferredMac;
    private PreferredCompression _PreferredCompression;
    private String _PreferredKeyExchange;
    private String _PreferredPublicKey;
    private List _AuthenticationMethod = PredicatedLists.createInvalidating(this, new AuthenticationMethodPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_AuthenticationMethod = new AuthenticationMethodPredicate();


    /**
     *  Gets the hostname attribute of the SshConnection object
     *
     *@return    The hostname value
     */
    public String getHostname() {
        return _Hostname;
    }


    /**
     *  Sets the hostname attribute of the SshConnection object
     *
     *@param  _Hostname  The new hostname value
     */
    public void setHostname(String _Hostname) {
        this._Hostname = _Hostname;
        if (_Hostname == null) {
            invalidate();
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String id() {
        return _Hostname.toString();
    }


    /**
     *  Gets the port attribute of the SshConnection object
     *
     *@return    The port value
     */
    public String getPort() {
        return _Port;
    }


    /**
     *  Sets the port attribute of the SshConnection object
     *
     *@param  _Port  The new port value
     */
    public void setPort(String _Port) {
        this._Port = _Port;
        if (_Port == null) {
            invalidate();
        }
    }


    /**
     *  Gets the username attribute of the SshConnection object
     *
     *@return    The username value
     */
    public String getUsername() {
        return _Username;
    }


    /**
     *  Sets the username attribute of the SshConnection object
     *
     *@param  _Username  The new username value
     */
    public void setUsername(String _Username) {
        this._Username = _Username;
        if (_Username == null) {
            invalidate();
        }
    }


    /**
     *  Gets the terminalType attribute of the SshConnection object
     *
     *@return    The terminalType value
     */
    public String getTerminalType() {
        return _TerminalType;
    }


    /**
     *  Sets the terminalType attribute of the SshConnection object
     *
     *@param  _TerminalType  The new terminalType value
     */
    public void setTerminalType(String _TerminalType) {
        this._TerminalType = _TerminalType;
        if (_TerminalType == null) {
            invalidate();
        }
    }


    /**
     *  Gets the preferredEncryption attribute of the SshConnection object
     *
     *@return    The preferredEncryption value
     */
    public PreferredEncryption getPreferredEncryption() {
        return _PreferredEncryption;
    }


    /**
     *  Sets the preferredEncryption attribute of the SshConnection object
     *
     *@param  _PreferredEncryption  The new preferredEncryption value
     */
    public void setPreferredEncryption(PreferredEncryption _PreferredEncryption) {
        this._PreferredEncryption = _PreferredEncryption;
        if (_PreferredEncryption == null) {
            invalidate();
        }
    }


    /**
     *  Gets the preferredMac attribute of the SshConnection object
     *
     *@return    The preferredMac value
     */
    public PreferredMac getPreferredMac() {
        return _PreferredMac;
    }


    /**
     *  Sets the preferredMac attribute of the SshConnection object
     *
     *@param  _PreferredMac  The new preferredMac value
     */
    public void setPreferredMac(PreferredMac _PreferredMac) {
        this._PreferredMac = _PreferredMac;
        if (_PreferredMac == null) {
            invalidate();
        }
    }


    /**
     *  Gets the preferredCompression attribute of the SshConnection object
     *
     *@return    The preferredCompression value
     */
    public PreferredCompression getPreferredCompression() {
        return _PreferredCompression;
    }


    /**
     *  Sets the preferredCompression attribute of the SshConnection object
     *
     *@param  _PreferredCompression  The new preferredCompression value
     */
    public void setPreferredCompression(PreferredCompression _PreferredCompression) {
        this._PreferredCompression = _PreferredCompression;
        if (_PreferredCompression == null) {
            invalidate();
        }
    }


    /**
     *  Gets the preferredKeyExchange attribute of the SshConnection object
     *
     *@return    The preferredKeyExchange value
     */
    public String getPreferredKeyExchange() {
        return _PreferredKeyExchange;
    }


    /**
     *  Sets the preferredKeyExchange attribute of the SshConnection object
     *
     *@param  _PreferredKeyExchange  The new preferredKeyExchange value
     */
    public void setPreferredKeyExchange(String _PreferredKeyExchange) {
        this._PreferredKeyExchange = _PreferredKeyExchange;
        if (_PreferredKeyExchange == null) {
            invalidate();
        }
    }


    /**
     *  Gets the preferredPublicKey attribute of the SshConnection object
     *
     *@return    The preferredPublicKey value
     */
    public String getPreferredPublicKey() {
        return _PreferredPublicKey;
    }


    /**
     *  Sets the preferredPublicKey attribute of the SshConnection object
     *
     *@param  _PreferredPublicKey  The new preferredPublicKey value
     */
    public void setPreferredPublicKey(String _PreferredPublicKey) {
        this._PreferredPublicKey = _PreferredPublicKey;
        if (_PreferredPublicKey == null) {
            invalidate();
        }
    }


    /**
     *  Gets the authenticationMethod attribute of the SshConnection object
     *
     *@return    The authenticationMethod value
     */
    public List getAuthenticationMethod() {
        return _AuthenticationMethod;
    }


    /**
     *  Description of the Method
     */
    public void deleteAuthenticationMethod() {
        _AuthenticationMethod = null;
        invalidate();
    }


    /**
     *  Description of the Method
     */
    public void emptyAuthenticationMethod() {
        _AuthenticationMethod = PredicatedLists.createInvalidating(this, pred_AuthenticationMethod, new ArrayList());
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException {
        if (_Hostname == null) {
            throw new MissingAttributeException("Hostname");
        }
        if (_Port == null) {
            throw new MissingAttributeException("Port");
        }
        if (_Username == null) {
            throw new MissingAttributeException("Username");
        }
        if (_TerminalType == null) {
            throw new MissingContentException("TerminalType");
        }
        if (_PreferredEncryption == null) {
            throw new MissingContentException("PreferredEncryption");
        }
        if (_PreferredMac == null) {
            throw new MissingContentException("PreferredMac");
        }
        if (_PreferredCompression == null) {
            throw new MissingContentException("PreferredCompression");
        }
        if (_PreferredKeyExchange == null) {
            throw new MissingContentException("PreferredKeyExchange");
        }
        if (_PreferredPublicKey == null) {
            throw new MissingContentException("PreferredPublicKey");
        }
    }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException {
        v.validate(_PreferredEncryption);
        v.validate(_PreferredMac);
        v.validate(_PreferredCompression);
    }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("SshConnection");
        w.attribute("Hostname", _Hostname.toString());
        w.attribute("Port", _Port.toString());
        w.attribute("Username", _Username.toString());
        w.leaf("TerminalType", _TerminalType.toString());
        m.marshal(_PreferredEncryption);
        m.marshal(_PreferredMac);
        m.marshal(_PreferredCompression);
        w.leaf("PreferredKeyExchange", _PreferredKeyExchange.toString());
        w.leaf("PreferredPublicKey", _PreferredPublicKey.toString());
        for (Iterator i = _AuthenticationMethod.iterator(); i.hasNext(); ) {
            w.leaf("AuthenticationMethod", ((String) i.next()).toString());
        }
        w.end("SshConnection");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("SshConnection");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            if (an.equals("Hostname")) {
                if (_Hostname != null) {
                    throw new DuplicateAttributeException(an);
                }
                _Hostname = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("Port")) {
                if (_Port != null) {
                    throw new DuplicateAttributeException(an);
                }
                _Port = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("Username")) {
                if (_Username != null) {
                    throw new DuplicateAttributeException(an);
                }
                _Username = xs.takeAttributeValue();
                continue;
            }
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("TerminalType")) {
            xs.takeStart("TerminalType");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _TerminalType = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("TerminalType", x);
            }
            xs.takeEnd("TerminalType");
        }
        _PreferredEncryption = ((PreferredEncryption) u.unmarshal());
        _PreferredMac = ((PreferredMac) u.unmarshal());
        _PreferredCompression = ((PreferredCompression) u.unmarshal());
        if (xs.atStart("PreferredKeyExchange")) {
            xs.takeStart("PreferredKeyExchange");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _PreferredKeyExchange = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("PreferredKeyExchange", x);
            }
            xs.takeEnd("PreferredKeyExchange");
        }
        if (xs.atStart("PreferredPublicKey")) {
            xs.takeStart("PreferredPublicKey");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _PreferredPublicKey = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("PreferredPublicKey", x);
            }
            xs.takeEnd("PreferredPublicKey");
        }
         {
            List l = new ArrayList();
            while (xs.atStart()) {
                if (xs.atStart("AuthenticationMethod")) {
                    xs.takeStart("AuthenticationMethod");
                    String s;
                    if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                        s = xs.takeChars(XMLScanner.WS_COLLAPSE);
                    } else {
                        s = "";
                    }
                    String uf;
                    try {
                        uf = String.valueOf(s);
                    } catch (Exception x) {
                        throw new ConversionException("AuthenticationMethod", x);
                    }
                    l.add(uf);
                    xs.takeEnd("AuthenticationMethod");
                } else {
                    break;
                }
            }
            _AuthenticationMethod = PredicatedLists.createInvalidating(this, pred_AuthenticationMethod, l);
        }
        xs.takeEnd("SshConnection");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static SshConnection unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static SshConnection unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static SshConnection unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((SshConnection) d.unmarshal(xs, (SshConnection.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof SshConnection)) {
            return false;
        }
        SshConnection tob = ((SshConnection) ob);
        if (_Hostname != null) {
            if (tob._Hostname == null) {
                return false;
            }
            if (!_Hostname.equals(tob._Hostname)) {
                return false;
            }
        } else {
            if (tob._Hostname != null) {
                return false;
            }
        }
        if (_Port != null) {
            if (tob._Port == null) {
                return false;
            }
            if (!_Port.equals(tob._Port)) {
                return false;
            }
        } else {
            if (tob._Port != null) {
                return false;
            }
        }
        if (_Username != null) {
            if (tob._Username == null) {
                return false;
            }
            if (!_Username.equals(tob._Username)) {
                return false;
            }
        } else {
            if (tob._Username != null) {
                return false;
            }
        }
        if (_TerminalType != null) {
            if (tob._TerminalType == null) {
                return false;
            }
            if (!_TerminalType.equals(tob._TerminalType)) {
                return false;
            }
        } else {
            if (tob._TerminalType != null) {
                return false;
            }
        }
        if (_PreferredEncryption != null) {
            if (tob._PreferredEncryption == null) {
                return false;
            }
            if (!_PreferredEncryption.equals(tob._PreferredEncryption)) {
                return false;
            }
        } else {
            if (tob._PreferredEncryption != null) {
                return false;
            }
        }
        if (_PreferredMac != null) {
            if (tob._PreferredMac == null) {
                return false;
            }
            if (!_PreferredMac.equals(tob._PreferredMac)) {
                return false;
            }
        } else {
            if (tob._PreferredMac != null) {
                return false;
            }
        }
        if (_PreferredCompression != null) {
            if (tob._PreferredCompression == null) {
                return false;
            }
            if (!_PreferredCompression.equals(tob._PreferredCompression)) {
                return false;
            }
        } else {
            if (tob._PreferredCompression != null) {
                return false;
            }
        }
        if (_PreferredKeyExchange != null) {
            if (tob._PreferredKeyExchange == null) {
                return false;
            }
            if (!_PreferredKeyExchange.equals(tob._PreferredKeyExchange)) {
                return false;
            }
        } else {
            if (tob._PreferredKeyExchange != null) {
                return false;
            }
        }
        if (_PreferredPublicKey != null) {
            if (tob._PreferredPublicKey == null) {
                return false;
            }
            if (!_PreferredPublicKey.equals(tob._PreferredPublicKey)) {
                return false;
            }
        } else {
            if (tob._PreferredPublicKey != null) {
                return false;
            }
        }
        if (_AuthenticationMethod != null) {
            if (tob._AuthenticationMethod == null) {
                return false;
            }
            if (!_AuthenticationMethod.equals(tob._AuthenticationMethod)) {
                return false;
            }
        } else {
            if (tob._AuthenticationMethod != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_Hostname != null) ? _Hostname.hashCode() : 0));
        h = ((127 * h) + ((_Port != null) ? _Port.hashCode() : 0));
        h = ((127 * h) + ((_Username != null) ? _Username.hashCode() : 0));
        h = ((127 * h) + ((_TerminalType != null) ? _TerminalType.hashCode() : 0));
        h = ((127 * h) + ((_PreferredEncryption != null) ? _PreferredEncryption.hashCode() : 0));
        h = ((127 * h) + ((_PreferredMac != null) ? _PreferredMac.hashCode() : 0));
        h = ((127 * h) + ((_PreferredCompression != null) ? _PreferredCompression.hashCode() : 0));
        h = ((127 * h) + ((_PreferredKeyExchange != null) ? _PreferredKeyExchange.hashCode() : 0));
        h = ((127 * h) + ((_PreferredPublicKey != null) ? _PreferredPublicKey.hashCode() : 0));
        h = ((127 * h) + ((_AuthenticationMethod != null) ? _AuthenticationMethod.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<SshConnection");
        if (_Hostname != null) {
            sb.append(" Hostname=");
            sb.append(_Hostname.toString());
        }
        if (_Port != null) {
            sb.append(" Port=");
            sb.append(_Port.toString());
        }
        if (_Username != null) {
            sb.append(" Username=");
            sb.append(_Username.toString());
        }
        if (_TerminalType != null) {
            sb.append(" TerminalType=");
            sb.append(_TerminalType.toString());
        }
        if (_PreferredEncryption != null) {
            sb.append(" PreferredEncryption=");
            sb.append(_PreferredEncryption.toString());
        }
        if (_PreferredMac != null) {
            sb.append(" PreferredMac=");
            sb.append(_PreferredMac.toString());
        }
        if (_PreferredCompression != null) {
            sb.append(" PreferredCompression=");
            sb.append(_PreferredCompression.toString());
        }
        if (_PreferredKeyExchange != null) {
            sb.append(" PreferredKeyExchange=");
            sb.append(_PreferredKeyExchange.toString());
        }
        if (_PreferredPublicKey != null) {
            sb.append(" PreferredPublicKey=");
            sb.append(_PreferredPublicKey.toString());
        }
        if (_AuthenticationMethod != null) {
            sb.append(" AuthenticationMethod=");
            sb.append(_AuthenticationMethod.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return PreferredCompression.newDispatcher();
    }


    /**
     *  Description of the Class
     *
     *@author     lee
     */
    private static class AuthenticationMethodPredicate
             implements PredicatedLists.Predicate {

        /**
         *  Description of the Method
         *
         *@param  ob  Description of the Parameter
         */
        public void check(Object ob) {
            if (!(ob instanceof String)) {
                throw new InvalidContentObjectException(ob, (String.class));
            }
        }

    }

}
