/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.transport;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


/**
 *  <p>
 *
 *  Generated by the JAXB toolkit to represent the hostAutorizations Element in
 *  the allowed hosts XML configuration file.</p> <p>
 *
 *  NOTE: This file should always be generated from HostAuthorizations.dtd &
 *  HostAuthorizations.xjs; the only amendment to the source code is to insert
 *  the package at the beginning of the file.</p>
 *
 *@author     Generated by JAXB
 *@created    31 August 2002
 *@version    1.0
 */
public class HostAuthorizations
         extends MarshallableRootElement
         implements RootElement {

    private List _AllowHost = PredicatedLists.createInvalidating(this, new AllowHostPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_AllowHost = new AllowHostPredicate();
    private List _DenyHost = PredicatedLists.createInvalidating(this, new DenyHostPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_DenyHost = new DenyHostPredicate();


    /**
     *  Gets the allowHost attribute of the HostAuthorizations object
     *
     *@return    The allowHost value
     */
    public List getAllowHost() {
        return _AllowHost;
    }


    /**
     *  Description of the Method
     */
    public void deleteAllowHost() {
        _AllowHost = null;
        invalidate();
    }


    /**
     *  Description of the Method
     */
    public void emptyAllowHost() {
        _AllowHost = PredicatedLists.createInvalidating(this, pred_AllowHost, new ArrayList());
    }


    /**
     *  Gets the denyHost attribute of the HostAuthorizations object
     *
     *@return    The denyHost value
     */
    public List getDenyHost() {
        return _DenyHost;
    }


    /**
     *  Description of the Method
     */
    public void deleteDenyHost() {
        _DenyHost = null;
        invalidate();
    }


    /**
     *  Description of the Method
     */
    public void emptyDenyHost() {
        _DenyHost = PredicatedLists.createInvalidating(this, pred_DenyHost, new ArrayList());
    }


    /**
     *  Description of the Method
     *
     *@exception  LocalValidationException  Description of the Exception
     */
    public void validateThis()
             throws LocalValidationException { }


    /**
     *  Description of the Method
     *
     *@param  v                                 Description of the Parameter
     *@exception  StructureValidationException  Description of the Exception
     */
    public void validate(Validator v)
             throws StructureValidationException {
        for (Iterator i = _AllowHost.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
        for (Iterator i = _DenyHost.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }


    /**
     *  Description of the Method
     *
     *@param  m                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void marshal(Marshaller m)
             throws IOException {
        XMLWriter w = m.writer();
        w.start("HostAuthorizations");
        if (_AllowHost.size() > 0) {
            for (Iterator i = _AllowHost.iterator(); i.hasNext(); ) {
                m.marshal(((MarshallableObject) i.next()));
            }
        }
        if (_DenyHost.size() > 0) {
            for (Iterator i = _DenyHost.iterator(); i.hasNext(); ) {
                m.marshal(((MarshallableObject) i.next()));
            }
        }
        w.end("HostAuthorizations");
    }


    /**
     *  Description of the Method
     *
     *@param  u                       Description of the Parameter
     *@exception  UnmarshalException  Description of the Exception
     */
    public void unmarshal(Unmarshaller u)
             throws UnmarshalException {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("HostAuthorizations");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
         {
            List l = PredicatedLists.create(this, pred_AllowHost, new ArrayList());
            while (xs.atStart("AllowHost")) {
                l.add(((AllowHost) u.unmarshal()));
            }
            _AllowHost = PredicatedLists.createInvalidating(this, pred_AllowHost, l);
        }
         {
            List l = PredicatedLists.create(this, pred_DenyHost, new ArrayList());
            while (xs.atStart("DenyHost")) {
                l.add(((DenyHost) u.unmarshal()));
            }
            _DenyHost = PredicatedLists.createInvalidating(this, pred_DenyHost, l);
        }
        xs.takeEnd("HostAuthorizations");
    }


    /**
     *  Description of the Method
     *
     *@param  in                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static HostAuthorizations unmarshal(InputStream in)
             throws UnmarshalException {
        return unmarshal(XMLScanner.open(in));
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static HostAuthorizations unmarshal(XMLScanner xs)
             throws UnmarshalException {
        return unmarshal(xs, newDispatcher());
    }


    /**
     *  Description of the Method
     *
     *@param  xs                      Description of the Parameter
     *@param  d                       Description of the Parameter
     *@return                         Description of the Return Value
     *@exception  UnmarshalException  Description of the Exception
     */
    public static HostAuthorizations unmarshal(XMLScanner xs, Dispatcher d)
             throws UnmarshalException {
        return ((HostAuthorizations) d.unmarshal(xs, (HostAuthorizations.class)));
    }


    /**
     *  Description of the Method
     *
     *@param  ob  Description of the Parameter
     *@return     Description of the Return Value
     */
    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof HostAuthorizations)) {
            return false;
        }
        HostAuthorizations tob = ((HostAuthorizations) ob);
        if (_AllowHost != null) {
            if (tob._AllowHost == null) {
                return false;
            }
            if (!_AllowHost.equals(tob._AllowHost)) {
                return false;
            }
        } else {
            if (tob._AllowHost != null) {
                return false;
            }
        }
        if (_DenyHost != null) {
            if (tob._DenyHost == null) {
                return false;
            }
            if (!_DenyHost.equals(tob._DenyHost)) {
                return false;
            }
        } else {
            if (tob._DenyHost != null) {
                return false;
            }
        }
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        int h = 0;
        h = ((127 * h) + ((_AllowHost != null) ? _AllowHost.hashCode() : 0));
        h = ((127 * h) + ((_DenyHost != null) ? _DenyHost.hashCode() : 0));
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("<<HostAuthorizations");
        if (_AllowHost != null) {
            sb.append(" AllowHost=");
            sb.append(_AllowHost.toString());
        }
        if (_DenyHost != null) {
            sb.append(" DenyHost=");
            sb.append(_DenyHost.toString());
        }
        sb.append(">>");
        return sb.toString();
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public static Dispatcher newDispatcher() {
        return AllowHost.newDispatcher();
    }


    /**
     *  Description of the Class
     *
     *@author     lee
     *@created    31 August 2002
     */
    private static class AllowHostPredicate
             implements PredicatedLists.Predicate {

        /**
         *  Description of the Method
         *
         *@param  ob  Description of the Parameter
         */
        public void check(Object ob) {
            if (!(ob instanceof AllowHost)) {
                throw new InvalidContentObjectException(ob, (AllowHost.class));
            }
        }

    }


    /**
     *  Description of the Class
     *
     *@author     lee
     *@created    31 August 2002
     */
    private static class DenyHostPredicate
             implements PredicatedLists.Predicate {

        /**
         *  Description of the Method
         *
         *@param  ob  Description of the Parameter
         */
        public void check(Object ob) {
            if (!(ob instanceof DenyHost)) {
                throw new InvalidContentObjectException(ob, (DenyHost.class));
            }
        }

    }

}
