/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.j2ssh.transport.cipher;

import javax.crypto.*;
import javax.crypto.spec.*;
import java.security.*;
import java.security.spec.*;
import com.sshtools.j2ssh.transport.AlgorithmOperationException;
/**
 *  <p>
 *
 *  This class is going to implement the blowfish-cbc encryption when I get
 *  around to doing it</p>
 *
 *@author     Lee David Painter (<A HREF="mailto:lee@sshtools.com">
 *      lee@sshtools.com</A> )
 *@version    1.0
 */

public class BlowfishCbc implements SshCipher {

    Cipher cipher;

    /**
     *  The blowfish algorithm name for SSH
     */
    protected static String algorithmName = "blowfish-cbc";


    /**
     *  Constructor for the BlowfishCbc object
     */

    public BlowfishCbc() { }


    /**
     *  <p>
     *
     *  Called to initate the cipher.</p>
     *
     *@param  mode                             ENCRYPT_MODE or DECRYPT_MODE
     *@param  iv                               The initialization vector data
     *@param  keydata                          The key data
     *@exception  AlgorithmOperationException  Thrown if a provider cannot be
     *      found for the cipher
     */
    public void init(int mode, byte[] iv, byte[] keydata) throws AlgorithmOperationException { }


    /**
     *  <p>
     *
     *  Transforms the data according to the cipher mode.</p>
     *
     *@param  data                             The untransformed data
     *@return                                  The transformed data
     *@exception  AlgorithmOperationException  Thrown if an error occurs
     */
    public byte[] transform(byte[] data) throws AlgorithmOperationException {

        return data;
    }


    /**
     *  <p>
     *
     *  Transforms the data according to the cipher mode.</p>
     *
     *@param  data                             The untransformed data
     *@param  offset                           The offset to start from in the
     *      untransformed data
     *@param  len                              The length of data to transform
     *@return                                  The transformed data
     *@exception  AlgorithmOperationException  Thrown if an error occurs
     */
    public byte[] transform(byte[] data, int offset, int len)
             throws AlgorithmOperationException {

        return data;
    }


    /**
     *  Gets the cipher block size
     *
     *@return    The blockSize value
     */
    public int getBlockSize() {
        return cipher.getBlockSize();
    }
}
