/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.sshterm;

import java.awt.event.*;
import javax.swing.*;
import java.awt.Frame;
import java.lang.String;
import com.borland.jbcl.layout.*;
import com.sshtools.util.ImagePanel;
/**
 *  <p>Displays an authentication banner</p>
 *
 *@author     Richard Pernavas (<A HREF="mailto:richard@sshtools.com">
 *      richard@sshtools.com</A> )
 *@created    31 August 2002
 *@version    1.0
 */

class BannerDialog extends CenterableDialog {
    JPanel panel1 = new JPanel();
    XYLayout xYLayout1 = new XYLayout();
    XYLayout xYLayout2 = new XYLayout();
    JButton jButtonOK = new JButton();
    ImagePanel icon = new ImagePanel("/com/sshtools/sshterm/banner.gif");
    JScrollPane jScrollPane1 = new JScrollPane();
    JTextArea jTextArea1 = new JTextArea();


    /**
     *  Constructs the BannerDialog object
     *
     *@param  bannerText  The SSH banner message text
     */
    public BannerDialog(Frame parent, String bannerText) {
        super(parent, "SSH Authentication - Banner Message", true);

        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

        this.jTextArea1.setText(bannerText);
        this.repaint();
    }


    /**
     *  Initializes the dialogs components
     *
     *@exception  Exception
     */
    void jbInit() throws Exception {
        panel1.setLayout(xYLayout1);
        this.getContentPane().setLayout(xYLayout2);
        jButtonOK.setText("OK");
        jButtonOK.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    BannerDialog.this.hide();
                }
            });

        jTextArea1.setBorder(BorderFactory.createEtchedBorder());
        jTextArea1.setEditable(false);
        jTextArea1.setLineWrap(true);

        xYLayout2.setWidth(470);
        xYLayout2.setHeight(223);

        panel1.add(jScrollPane1, new XYConstraints(61, 7, 414, 176));
        panel1.add(icon, new XYConstraints(13, 10, 40, 39));
        panel1.add(jButtonOK, new XYConstraints(393, 190, 82, 26));
        jScrollPane1.getViewport().add(jTextArea1, null);
        getContentPane().add(panel1);
        this.setSize(500,245);
        this.setResizable(false);
    }
}
