/*
* Copyright (c) 2002 Sshtools.com All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list
* of conditions and the following disclaimer.
*
* Redistributions in binary form must reproduce the above copyright notice, this
* list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* Neither the name of the Sshtools.com nor the names of its contributors may be
* used to endorse or promote products derived from this software without specific
* prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

package com.sshtools.sshterm;

import javax.swing.Action;

/**
 *  Describes the Close action of the SshTerminalFrame
 *
 *@author     Lee David Painter (<A HREF="mailto:lee@sshtools.com">
 *      lee@sshtools.com</A> )
 *@created    31 August 2002
 *@version    1.0
 */
class CloseAction extends StandardAction {

    private final static String ACTION_COMMAND_KEY_CLOSE = "close-command";
    private final static String NAME_CLOSE = "Close";
    private final static String SMALL_ICON_CLOSE = "";
    private final static String LARGE_ICON_CLOSE = "";
    private final static String SHORT_DESCRIPTION_CLOSE = "Close the current connection";
    private final static String LONG_DESCRIPTION_CLOSE = "Close the current connection";
    private final static int MNEMONIC_KEY_CLOSE = 'C';


    /**
     *  Constructor
     */
    public CloseAction() {
        putValue(Action.NAME, NAME_CLOSE);
        putValue(Action.SMALL_ICON, getIcon(SMALL_ICON_CLOSE));
        putValue(LARGE_ICON, getIcon(LARGE_ICON_CLOSE));
        putValue(Action.SHORT_DESCRIPTION, SHORT_DESCRIPTION_CLOSE);
        putValue(Action.LONG_DESCRIPTION, LONG_DESCRIPTION_CLOSE);
        putValue(Action.MNEMONIC_KEY, new Integer(MNEMONIC_KEY_CLOSE));
        putValue(Action.ACTION_COMMAND_KEY, ACTION_COMMAND_KEY_CLOSE);
    }
}